package Ightaria;

import java.awt.*;
import java.lang.Math;

import DrawTexts.*;
import DrawHills.*;
import CalculusAndVectors.*;
import Globals.*;
import Statistics.*;









//***************************************************************
/** <pre>

    This Class contains HFold, Path in HFold, and FlatPath.
    It should be truly three classes, but they are in one to
    avoid proliferation of java-class-files.
    Terminology: Obs, observer, is really a Vessel in this Class.
    In other words, driver's eyes direction can be different than
    direction of the Vessel, but driver is ignored in this class.

</pre> */
//***************************************************************

public class HFold {




/** Radius of HF in PFold.
    It's value is used in model calculations. 
    Radius is st only to provide a concrete value
    to encourage Observer to guess it.
*/  public static double hfRadius=1789000.;        


//A n a l y t i c a l   p a r t.


    /** Vessel's basis in PFold at recent stop.
    */
    static UBasis  vs;  


    //Should be static:
    /**   Vessel's basis after current move from last stop.
          In other words, current basis during Vessel's travel.
          Can be = vs if no move yet done after last stop.
    */
    public static UBasis  v;

    
    /** Angle-like coodinates: Current angles theta and phi. */
    static double t,p;      



//P a t h   in   P F o l d


  // VesselMotionFSM parameters
  // States:
                                         public static final int stCOMPLETED   = 1;
                                         public static final int stROTATING    = 2;
                                         public static final int stMOVING      = 4;
  // Substates
                                         public static final int stSubSTARTUP  = 8;
                                         public static final int stSubTURNED   = 16;

  public static String[] stString = {         " ", "TRIP", "ROTATING", "", 
                                         "MOVING",     "",         "", "",
                                      "STARTPOND",     "",         "", "",
                                               "",     "",         "", "",
                                         "TURNED"
                                    };

  /** Principal path sc. state  */       public static       int stAte;




  /** Number of Stops = Completed Moves. Stop index. */    public static int Sx;
  /** Sx1 = Sx + 1 when motion is incomplete. */           public static int Sx1;               
  /** Number of stops limit. */                            static        int iL   = 10000;

  //Shortcuts for last elements in array are indented:
  //Principals:
  static double vTauIncr[] = new double [iL];  //Tau increment.
  static double vFpIncr[]  = new double [iL];  //Psy increment.
      //vTauIncr[0] has no matter. No move happened before stop 0.
      static double psy;
      static double tau;
      static double move;  //tau * hfRadius;
      static double lastStraightMoves;
  //Navigational. Must be set at stop 0:


  //Not used yet. For future ability to restart from an 
  //arbitrary stop:
  static double rT[]  = new double [iL];       //Global Sph. coord of obs. pos.
  static double rP[]  = new double [iL];






//F l a t   M a p   M a s t e r   V a l u e s

   /** Vessel's Azi along the path. Master value.
      (Accomulated psy) */
   static double vessFp[] = new double [iL];

   /** Vessel's Current (accoumulated) Azi.
       Shortcut to: vFp = vessFp[Sx1]. */
   static double vFp;

   /** vFp at last stop.
       Shortcut to vFpS = vessFp[Sx]. */
   static double vFpS;     

   /** Driver's Current (Face) Azi. Master value. */
   static double oFp;            

   //Illustrative:
   static double vX[]  = new double [iL];       //Accomulated flat path x.
   static double vY[]  = new double [iL];
   static double flatX, flatY;





/** Population object belonging to this HomeFold. */
static Pop ppl;










//G r a p h i c s   p a r t:


 public static SPad spFDigits;
        static SPad        sp;    //Altigate Map.
        static SPad    spFlat;    //Flat Map.
        static SPad spMDigits;
        static SPad spMainScreen;
        static SPad spDialog;

//Was working:
/*
 public static SPad spFDigits     = SPad.sPad[SPad.W_];
        static SPad        sp     = SPad.sPad[SPad.d_];    //Altigate Map.
        static SPad    spFlat     = SPad.sPad[SPad.c_];    //Flat Map.
        static SPad spMDigits     = SPad.sPad[SPad.E_];
        static SPad spMainScreen  = SPad.sPad[SPad.C_];
        static SPad spDialog      = SPad.sPad[SPad.N_];
*/
              

 static SingleHill  img;         //Image.
 static SingleHill  imgLow;      //Low part of Manifold.

 static Color oColor          = new Color( 255<<8 | 255 );      //Vessel? Oblserver in Manifold related.
 static Color flatPathColor   = new Color( 200<<16 | 200<<8 );
 static Color driverAxisColor = new Color(100<<16|255<<8|100);




//G r a p h i c s   v a r i a b l e s:
public static boolean doPaintScratchMaps;
// Main Scene Window           
/** Orientation of Driver's face  */  static double drDirX=0., drDirY=1., drDirZ = 0.;



//M a n i f o l d 's   S c r a t c h   P a d:

   static Color imgColor = new Color( 100 <<8 | 100 ); //Don't make it too bright.
                                                //Otherwise too hard to see axes. 
   static int imgRadius = 100;           //Radius of Manifold. Must be equal to
                                  //radius in hill's function.
   static int axisLen   = 40;            //Observer's axis on Manifold.
                                  //Make them small to "emphasize" how big is the Land.
                                  //Manifold's center is an origin.

   static Color axisColor = new Color ( 180<<16 | 180<<8 | 255 );


//3D   M a p
/** 3D Map parameters           */  static int centerX=200, centerY=-100;
/** Driver's position when 
    observing HomeFold on 
    scratch pad.                */  static int drX=130, drY=-450, drZ=400;





// For Flat Map Graphics:
/** Center of picture on Flat Map */ static int xCenter, yCenter;
/** Must be less than xCenter-5, 
    yCenter-5. */                    static int flatScreenAxisLen = 20;   

//To fit and draw on flat pad.
/** Gabarits of path flat map. 
    Don't make them zero.   */   static double diamX, diamY;
/** For added new stop      */   static double diamX1, diamY1;
/** Must be set inside of 
    procedures              */   static double flatScale;   
 





/** Azi(Path) M e a s u r e m e n t  S c e n a r i o */

  // Parameters
  // States:                
                            public static final int stDOFF          = 0;
                            public static final int stDSTART        = 1;
                            public static final int stDPREPARING    = 2;
                            public static final int stDMEASURING    = 4;
                            public static       int stDAte;
  // Substates
                            public static final int stDSub90DEGREES = 8;
                            public static       int stDSub;


/** Requires necessary perpendicularity 
    accuracy and restricts accurate digigs
    for third degree Taylor member:
*/
public static double derivatorTrustedGeneralAccuracy;

public static double sphereNavigationTrustedGeneralAccuracy;


static private Hill           measH;

/** Abs value in respect to Vessel */
static private double  measAzi;

/** measNu = |Azi| - Pi/2 */
static private double  measNu;  

static private double  measTau0;
static private double  measTanTau0;
static private double  measDerivative0;
static private double  measX0, measY0;




//A u x i l i a r y:
static double a,b,c;





//******************************************
// F o r m e r    C o n s t r u c t o r
//==========================================
public static void initiate() {


      spFDigits     = SPad.sPad[SPad.W_];
      sp            = SPad.sPad[SPad.d_];    
      spFlat        = SPad.sPad[SPad.c_]; 
      spMDigits     = SPad.sPad[SPad.E_];
      spMainScreen  = SPad.sPad[SPad.C_];
      spDialog      = SPad.sPad[SPad.N_];


      xCenter = spFlat.xL /2;
      yCenter = spFlat.yL /2;

      img     = new SingleHill(          //Hill meant the upper part of Manifold.
                          sp,            //The same sp to draw and for messages.   
                          sp,
                          sp.xL, 
                          sp.yL,
                          centerX,
                          centerY,
                          Hill.funUpperSphere
                );
      img.OwnColor = imgColor;
      imgLow  = new SingleHill(          //Hill meant the upper part of Manifold.
                          sp,            //The same sp to draw and for messages.   
                          sp,
                          sp.xL, 
                          sp.yL,
                          centerX,
                          centerY,
                          Hill.funLowSphere
                );
      imgLow.OwnColor = imgColor;
      restart();

}
//==========================================
// F o r m e r    C o n s t r u c t o r
//******************************************





//================================================================
//  S u p p l y   a n d   r e l e a s e   r e s o u r c e s
//----------------------------------------------------------------
    public static void supplyGraphics() {
        imgLow.supplyGraphics();
        img.supplyGraphics();
    }
    public static void releaseGraphics() {
        imgLow.releaseGraphics();
        img.releaseGraphics();
    }
//----------------------------------------------------------------
//  S u p p l y   a n d   r e l e a s e   r e s o u r c e s
//================================================================





//==========================================
// R e s t a r t e r s
//------------------------------------------
public static void restart() {

       //Reset scenario:
       stAte = stCOMPLETED | stSubSTARTUP;
        

       /* Start position in PFold is: e[2]=0.,0.,1: */

       vs  = new UBasis( new DVector( 1., 0., 0. ),
                         new DVector( 0., 1., 0. ),
                         new DVector( 0., 0., 1. )
             );

       v   = new UBasis( new DVector( 1., 0., 0. ),
                         new DVector( 0., 1., 0. ),
                         new DVector( 0., 0., 1. )
             );

       oFp = 0.;            

       Sx   = 0;
       Sx1  = 0;               

       vFp = 0.;                      //Fill shortcut.
       vFpS = 0.;                     //Fill shortcut.
       vessFp[Sx1] = vFp;             //Fill master.


       vFpIncr[Sx1] = 0.;             //Fill master.
       psy          = 0.;             //Fill shortcut.

       tau          = 0.;             //Fill shortcut.
       vTauIncr[Sx1] = tau;           //Fill master.

       move  = 0.;

       //Remember FlatPath:
       flatX   = 0.;       //Fill shortcut.
       flatY   = 0.;       //Fill shortcut.
       vX[Sx1] = 0.;       //Fill master.  
       vY[Sx1] = 0.;       //Fill master.


       rT[0]     = 0.;     //Spher coord. of global position.
       rP[0]     = 0.;

       //To fit and draw on flat pad:
       diamX=20.;
       diamY=20.;


       /** Azi(Path) M e a s u r e m e n t  S c e n a r i o */
       toggleMeasurement(false);
       reset_defaults();

}

public static void reset_defaults() {
       derivatorTrustedGeneralAccuracy = 1.e-12;
       sphereNavigationTrustedGeneralAccuracy = 1.e-14;
}

//------------------------------------------
// R e s t a r t e r s
//==========================================










     


//******************************************
// M e t h o d s
//******************************************
 

//***********************************************
//     Bookkeep Last Position and Orientation.
//===============================================
/** <pre>

  Make vessel turn and move along geodesic.
  psy - turn; tau - move.
  psy = Bridge.vFpAccIncr.

</pre>*/
public static void updatePathLastMotion() {

       double loPsy     = Bridge.vFpAccIncr;
       double loPsyIncr = Bridge.vFpAccIncr - psy;
       double loPath    = Bridge.oAccomulatedPath;
       double absLoPsy  = Math.abs(loPsy);
       double absLoPath = Math.abs(loPath);

       switch( (stAte & stCOMPLETED) | 
               (stAte & stROTATING ) |
               (stAte & stMOVING)    
             )  {
       case stCOMPLETED:
            //GS.con("stAte=stCOMPLETED" + stAte);
       case stROTATING:
            if( absLoPath>1.e-22 ) { 
                stAte = stMOVING;
                //GS.con("stAte:ROTATING...-->MOVING" + stAte);
                if( absLoPsy>1.e-22  ) stAte |= stSubTURNED;
            }else{
                if( absLoPsy>1.e-22  ) {
                    stAte = stROTATING | stSubTURNED;
                    //GS.con("stAte stROTATING...-->stROTATING | stSubTURNED" + stAte);
                } 
            }
            break;
       case stMOVING:
            if( absLoPath<1.e-22 ) {
                //stAte = stROTATING; 
                if( Math.abs(loPsyIncr)>1.e-22 ) {
                    stAte = stROTATING | stSubTURNED;
                    //GS.con("stAte-->stROTATING | stSubTURNED" + stAte);
                }
            }else{
                if( Math.abs(loPsyIncr)>1.e-22 ) {

                    //Key's supplier broke rules.
                    //Do self protection:

                    //Destroy Derivator's work if any:
                    if( stDAte != stDOFF ) stDAte = stDSTART;

                    //Assume stop key was lost and turn action attempted
                    //while move is not finalized. Fire finalization:
                    FinalizeStop();

                    //Continue after stop:
                    loPsy = loPsyIncr;
                    loPath = 0.; //Lose path.

                } //else continue MOVING
                //GS.con(" cintinue moving. State=" + stAte);
           }
        } // switch

       Sx1      = Sx+1;           //do1 array index limit protection:

       vFpIncr[Sx1] = loPsy;                         //Fill master.
       psy          = loPsy;                         //Fill shortcut.

       vFp = Vec.fixAzi(vessFp[Sx] + loPsy);         //Fill shortcut:
       vessFp[Sx1] = vFp;                            //Fill master.

       move  = loPath;                               //Fill shortcut. 
       tau   = loPath / hfRadius;                    //Fill shortcut.
       vTauIncr[Sx1] = tau;                          //Fill master.



          if( Math.abs(loPsy) > 1.e-50 ) stAte |= stSubTURNED;
          


       //Remember FlatPath:
       flatX   = vX [Sx] - loPath * Math.sin(vFp);     //Fill shortcut.
       flatY   = vY [Sx] + loPath * Math.cos(vFp);     //Fill shortcut.
       vX[Sx1] = flatX;                                //Fill master.  
       vY[Sx1] = flatY;                                //Fill master.

       //==================================================================
       // P a t h   C a l c u l a t i o n s.   P r i n c i p a l   P a r t.
       //------------------------------------------------------------------
       UBasis.Assign( vs, v );
       if( psy != 0. ) {
           v.RotateAroundZ( Math.cos(psy), Math.sin(psy) );    //Make turn.
       }
       if( tau != 0. ) {
           //Recall: positive move along observer's local y 
           //is clockwise therefore is negative in HF:
           v.RotateAroundX( Math.cos(tau), -Math.sin(tau) );   //Make move.
       }
       //==================================================================

       v.e[2].FindSphericalCoord();
       t = v.e[2].t;  //Fill shortcuts.
       p = v.e[2].p;  //Fill shortcuts.

       //For display. Not part of calculations:
       //do2 perhaps dx, dy was better:
       Terrain.setObsFlatPosition(flatX,flatY); //do1. Supply Totals.
       diamX1   = Math.max(diamX, Math.abs(flatX));
       diamY1   = Math.max(diamY, Math.abs(flatY));

       doPaintScratchMaps = true;

}
//===============================================
//     Bookkeep Last Position and Orientation.
//***********************************************





//***********************************************
//     FinalizeStop
//===============================================
/** Runs derivator */
public static void FinalizeStop() {

       if( (stAte & stMOVING) != stMOVING ) return;

       stAte = (stAte & stSubTURNED) | stCOMPLETED;
       Bridge.navigationMessage +=" STOP";
       
       //Clear replica of azi increment:
       //It must start over to accomulate rotation:
       Bridge.vFpAccIncr  = 0.;
       //Clear replica of steps increment:
       //It must start over to accomulate movement:
       Bridge.oAccomulatedPath = 0.;  

       Sx = Sx1; 
       vFpS = vFp;    //Fill the shortcut.
       UBasis.Assign( v, vs );
       Stat.distanceTraveled +=move;
         
       if( psy !=0 ) {
           lastStraightMoves = move;
       } else {
           lastStraightMoves += move;
       }
       
       if( GS.deb ) {
           //GS.con("Finalizing Stop. Move=" + move + " Psy=" + psy );
           //spFDigits.wr ("Stopped: Sx is set from " + (Sx-1) + " to " + Sx );
           //spFDigits.wr ("pIncr=" + psy + " Total=" + vFp ); //debug
           //spFDigits.wr ("move  =" + move + " total=" + flatY ); //debug
           //spFDigits.wr ("total Y before=" + vY[Sx-1]); //debug
           //if( Sx > 1 ) spFDigits.wr ("Y before2=" + vY[Sx-2]); //debug
       }
        
       //--------------------------------
       //Finalize illustrative variables:
       rT[Sx] = t;
       rP[Sx] = p;
       //--------------------------------

       //Graphics:
       diamX = diamX1;
       diamY = diamY1;
       doPaintScratchMaps = true;
 
}
//===============================================
//     FinalizeStop
//***********************************************












//************************************************
// Measurement scenario methods
//================================================

public static void toggleMeasurement(boolean b) {
              stDAte = b ? stDSTART : stDOFF;
}

/** Must run when motions and scene relaxed */
public static void runAngleminerAnDerivator() {

     ppl.displayAngleMiner();
     if( stDOFF == stDAte ) return;

     measH = ppl.hills[ppl.iMeasuredHill];

     //Special events:
     if( Scenario.level <= Scenario.levJustBorn && 
           !Scenario.cheatEnabled ) {
           spFDigits.wr ("  D e r i v a t o r   not available ... ");
           spFDigits.wr("Insufficient Drivers's level ...");
           spFDigits.wr("Level " + Scenario.levNavigationExpert + " or higher required ... ");
           return;
     }
     if( measH.measureTooClose && measH.measureFarOrClose == 0 ) {
           stDAte = stDSTART;
           spFDigits.wr ("  D e r i v a t o r   is idle ... ");
           spFDigits.wr ("Star too close ... ");
           return;
     }

     

     //Normal events:
     int eventOfMotionFSM =  mainState();

     //GS.con("DState=" + stDAte + "  DSub=" + stDSub + " stAte=" + eventOfMotionFSM  ); 

     switch( stDAte ) {
     case stDSTART:
          if( eventOfMotionFSM == stMOVING  ) {
              spFDigits.wr("Cannot prepare Derivator");
              spFDigits.wr("when moving ... ");
              return;
          }
          stDAte = stDPREPARING;
          spFDigits.wr("Prepare in stDStart");
          //GS.con("Prepare in stDStart");
          prepareDerivator();  //Can set 90^
          return;

     case stDPREPARING:

          if( stDSub90DEGREES == stDSub ) {
              //if( eventOfMotionFSM == stCOMPLETED ||
              if( eventOfMotionFSM == stMOVING  ) {
                  stDAte = stDMEASURING;
                  measUreAndPrint();
                  return;
              }
              spFDigits.wr("Perp but no move");
              //GS.con("Perp but no move");
          }
          if( eventOfMotionFSM == stMOVING  ) {
              spFDigits.wr("No perpendicularity reached ...");
              spFDigits.wr("Reinitializing Derivator ... ");
              stDAte = stDSTART;
              return;
          }
          //stCOMPLETED and stROTATING are now:
          spFDigits.wr("No (Perp with move)");
          //GS.con("No (Perp with move)");
          prepareDerivator();  //Can set 90^
          return;
 
    case stDMEASURING:
          if( eventOfMotionFSM == stROTATING ) {
              stDAte = stDPREPARING;
              //GS.con("Driver turned Vessel ..."); 
              spFDigits.wr("Driver turned Vessel ...");
              spFDigits.wr("Preparing Derivator again ... ");
              prepareDerivator();  //Can set 90^
              return;
          }
          measUreAndPrint();

    }
}  //runDerivatorFSM

 



/**  Preparing for measurement along straight path
     or terminating this measurement.
     Turns on on special condition.
     Called from Bridge.
*/
public static void prepareDerivator() {


       //==================================================
       // Begin to draw on Derivator's SPad
       spFDigits.wr ("  D e r i v a t o r   prepares ...");
       //==================================================

       measAzi    = Math.abs(measH.twin_hVp(false)); //Slow
       measNu     = measAzi-Vec.PI2;

       spFDigits.wr ("p=|Azi|.     n=p-PI/2.");
       spFDigits.wr ("p=" + measAzi );
       spFDigits.wr ("n=" + measNu );
       
       if( Math.abs(measNu) >= derivatorTrustedGeneralAccuracy ) {
           spFDigits.wr ("No right angle reached yet ..."); 
           spFDigits.wr ("Perpendicularity accuracy must be"); 
           spFDigits.wr ("   " + derivatorTrustedGeneralAccuracy); 
           //GS.con("stDSub dropped to 0");
           stDSub = 0;  
           return;
       }
 

       stDSub = stDSub90DEGREES;  
       //GS.con("Reached stDSub=" +stDSub);
       //Emphasize perpendicularity ...
       //Highlight the background: ...
       spFDigits.ClearTerminalFromCurrentPosition(new Color(20<<16|30<<8|30));

       //Yes, we move perpendicularly to direction to star.
       measX0 = vX[Sx1];
       measY0 = vY[Sx1];
       measH.twin_hVp(true);
       measTau0        = measH.twinTau;
       measTanTau0     = measH.twinTangentTau;
       measDerivative0 = measH.twinDerivative;
       spFDigits.wr ("T'(0)=" + measDerivative0 );
       spFDigits.wr (" "); 
       spFDigits.wr ("OPERATES.  WAITING FOR STEPS ***"); 
       doPaintScratchMaps = true;

} //public void prepareDerivator




/** After non-zero move perpendicular to direction to measured star 
    this proc tracks dependence T(azi) */
static private void measUreAndPrint() {

 
        boolean showAll = Scenario.cheatEnabled || Scenario.level >= Scenario.levHFConqueror;
        
        double w  =  vX[Sx1] - measX0;
        double w2 =  vY[Sx1] - measY0;
        double loSquaredFlatDistance = w*w + w2*w2;
        double flatDistance = Math.sqrt( loSquaredFlatDistance );

        measAzi    = Math.abs(measH.twin_hVp(false));

        //-------------------------------------------------------------
        //  Backware move corrections
        //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
        //If Vessel moved backward, then we must make sure that 
        //x is negative.
        //How to know backward or not?:
        //double wScalarProduct = Math.cos(vFp+PI/2.) * w + 
        //Math.sin(vFp+PI/2) * w2;
        //Or:
        double wScalarProduct = Math.cos(vFp) * w2 - Math.sin(vFp) * w;
        //For the rest of this subroutine, the only correction related
        //to path's direction will be this:
        //Backward paths will be negative:
        if( wScalarProduct < 0 ) flatDistance = -flatDistance;
        //- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -
        //  Backware move corrections
        //-------------------------------------------------------------

        double measAziToNormal     = measAzi-Vec.PI2;
        double loTan = Math.tan(measAziToNormal);

         
        //==================================
        // Begin to draw on Derivator's SPad
        //==================================
        spFDigits.wr ("   D e r i v a t o r    operates ... ");
        spFDigits.wr ("Path is perpendicular ... ");
        spFDigits.wr ("x=path; n=|Azi|-PI/2. T=Tan(n).");
        spFDigits.wr ("f=T/( xT '(0) )=1 - c*x*x.  T ' =dT/dx" );
        spFDigits.wr ("n(0)="             + measNu);
        spFDigits.wr ("n   ="             + measAziToNormal);

        spFDigits.wr ("T '(0)="            + measDerivative0);

        //Sorry, this line does not fit:
        //Move above legends into help and unremark this line:
        //if(showAll)  spFDigits.wr ("EDistance=" + (1./measDerivative0));

        spFDigits.wr ("T="                + loTan);
        spFDigits.wr ("x="                + flatDistance);


        //Self protector: stMOVING but move = 0
        if( Math.abs(move) < 1.e-12 || loSquaredFlatDistance < 1.e-12 ) {
            spFDigits.wr ("Do steps to measure more ... ");
            return;
        }
        

        //Emphasize this great event of obtaining second Taylor members ...
        //Highlight the background: ...
        spFDigits.ClearTerminalFromCurrentPosition(new Color(30<<16|50<<8|50));

        double fDividedByDerivative = loTan /( measDerivative0 * flatDistance);
        spFDigits.wr ("f=" + fDividedByDerivative); 

        double secondMember         = 1. - fDividedByDerivative;
        spFDigits.wr ("1-f=" + secondMember);

        if(secondMember < 1.e-13) {
           spFDigits.wr("Straight path is too short ... ");
           spFDigits.wr("Perhaps farer path gives more measurable ");
           spFDigits.wr("contribution to azi ...");
           return;
        }



        /*
        //This is a draft of a proper method. We don't have time to implement it
        //and will cheat.
        int approxOrderOfSecondMember =  (int) ( - Math.log(secondMember)/Math.log(10.));
        int approxOrderOfThirdTaylorMember = 2*approxOrderOfSecondMember + 1;
        int approxRestrictiveOrder = Math.min(approxOrderOfThirdTaylorMember, 13);
        int accuracyDigits         =  approxRestrictiveOrder - approxOrderOfSecondMember;
        GS.con("????=" + approxOrderOfSecondMember + 
               " Third=" + approxOrderOfThirdTaylorMember + 
               " Min=" + approxRestrictiveOrder + 
               " Acc=" + accuracyDigits);
        */

        //Cheat:
        double approxSecondMember     = loSquaredFlatDistance /( hfRadius * hfRadius );
        double approxThirdMember      = approxSecondMember * approxSecondMember  /120.;
               approxSecondMember     = approxSecondMember /6.;
        double restrictor             = Math.max(derivatorTrustedGeneralAccuracy, 
                                        approxThirdMember);

        //Next digit after accuracyDigits can be valuable, but we will be cautious,
        //will suspect two digits, and subsrtruct 2:
        int accuracyDigits            = -2 + (int) (Math.log(approxSecondMember/restrictor)/Math.log(10.));

        //do2 Put somewhere on GUI instead of console:
        if(Scenario.cheatEnabled) {
           //GS.con("Cheated Second TMemb=" + approxSecondMember + " Cheated Third=" + approxThirdMember);
           //GS.con("accuracyDigits=" + accuracyDigits);
        }

        //This probably necessary if 2^31-1?:
        //if(accuracyDigits<0||accuracyDigits<1) return;

        if(accuracyDigits<1) return;

        double secondCoefficient      = secondMember / loSquaredFlatDistance;
        double curvatureRadius        = Math.sqrt( 1./(6*secondCoefficient) );
        spFDigits.wr("c=" + GS.scF(secondCoefficient,accuracyDigits+1) + 
                     " ( " + accuracyDigits  + " digits accuracy ). ");

        if(showAll) {
            String s = "Radius = " + GS.scF(curvatureRadius,accuracyDigits+1) + 
                       " (" + accuracyDigits  + " dig. acc). ";     
            spFDigits.wr(s);
        }        
}

//================================================
// Measurement scenario methods
//************************************************








/** Paint Maps, Research Data */
public static void paintMotionsAndMeasure(int frameNumber) {
        
       if( !doPaintScratchMaps ) return;
       doPaintScratchMaps = false;

       //measUreAndPrint();
       DrawFlatPath();


       if( !Scenario.cheatEnabled  &&
           Scenario.level < Scenario.levHFConqueror ) {
           spMDigits.wrc("ALTIGATE PATH");
           sp.wrc("ALTIGATE");
           return;
       }

       PrintMDigits();

       sp.wrc("ALTIGATE");
       sp.wr ("Radius=" + hfRadius );
       sp.wr ("Stop " + Sx + " Move " + Sx1);
       sp.wr ("phi  =" + p);
       sp.wr ("theta=" + t);

       sp.wr ("psy="  + (360.*psy/(2*Math.PI)) + "^");
       sp.wr ("arc="  + tau * hfRadius );

       sp.skipLines(6);

       sp.wr ("rx=" + v.e[2].x);
       sp.wr ("ry=" + v.e[2].y);
       sp.wr ("rz=" + v.e[2].z);

           //do2 does not work why?
           //imgLow.paintHill(  drX,drY,drZ,    drDirX, drDirY, drDirZ,                
           //                   frameNumber, false, false, false);

       img.paintHill   (  drX,drY,drZ,    drDirX, drDirY, drDirZ,                
                          frameNumber, false, false, true, 0.);
       DrawLocalUBasisOnUSphere( v.e[2], v );
       sp.DrewBorder();
       doPaintScratchMaps = false;
}


static private void PrintMDigits() {

        spMDigits.wrc("ALTIGATE PATH");

        spMDigits.wr ("Stop " + Sx + ". Coordinates:");
        spMDigits.wr ("phi=" + p);
        spMDigits.wr ("phi="   + Vec.RAD2DEG*p + "^");
        spMDigits.wr ("theta=" + t);
        spMDigits.wr ("theta=" + Vec.RAD2DEG*t + "^");
        spMDigits.wr ("rx=" + v.e[2].x);
        spMDigits.wr ("ry=" + v.e[2].y);
        spMDigits.wr ("rz=" + v.e[2].z);
        spMDigits.wr ("M o v e  " + Sx1 + ".  P a r a m e t e r s:");
        spMDigits.wr ("psy="  + (360.*psy/(2*Math.PI)) + "^");
        spMDigits.wr ("arc="  + tau * hfRadius );
        spMDigits.wr ("tau="  + tau);
        double d     = Vec.UBasisDeviation( v );
        spMDigits.wr ("Accuracy Loss= ");
        spMDigits.wr ("   " + d);

}


// FlatMap Display Parameters
private static final int flatMap_LEGEND_INTERVAL_DISPLAY_X = 10;
private static final int flatMap_LEGEND_INTERVAL_DISPLAY_Y = 13;


static private void DrawFlatPath() {

        Graphics g = spFlat.g;

        spFlat.wrc("START MAP");
        spFlat.wr ("Stop " + Sx + ". Trip " + Sx + ".");
        spFlat.skipLines(7);
        spFlat.wr ("x="      + flatX);
        spFlat.wr ("y="      + flatY);
        spFlat.wr ("course=" + vFp);
        spFlat.wr ("course=" + Vec.RAD2DEG*vFp + "^");
        spFlat.wr ("move="   + move);
        spFlat.wr ("turn="   + psy);
        spFlat.wr ("turn="   + Vec.rad2Degr(psy) + "^");

        //Flat pad screen coordinates:        
        //Mock init:
        int x2=xCenter;
        int y2=xCenter; 
        int x1=xCenter;
        int y1=yCenter;

        int lastPrintedLegendX = x1;
        int lastPrintedLegendY = y1;

        double flatScaleX = ((double) (xCenter - flatScreenAxisLen - 8)) / diamX1;
        double flatScaleY = ((double) (yCenter - flatScreenAxisLen - 8)) / diamY1;
        flatScale         = Math.min(flatScaleX,flatScaleY);
        

        for(int j=1; j<=Sx1; j++ ) {

            int xM = (int) (vX[j] * flatScale);
            int yM = (int) (vY[j] * flatScale);

            x2 = xCenter + xM;
            y2 = yCenter - yM;

            g.setColor  ( flatPathColor );

            //Line segment is drawn for stCOMPLETED or stMOTION
            //except for start point:
            g.drawLine  ( x1, y1, x2, y2 );

            //Don't print legend for non-finalized step:
            if( j != Sx1 || Sx == Sx1 ) {
                if( j == 0 ||
                    Math.abs(lastPrintedLegendX-x2) >= flatMap_LEGEND_INTERVAL_DISPLAY_X ||
                    Math.abs(lastPrintedLegendY-y2) >= flatMap_LEGEND_INTERVAL_DISPLAY_Y 
                  ){
                    lastPrintedLegendX = x2;
                    lastPrintedLegendY = y2;
                    g.drawString( " " + j, x2,y2 );
                }
            }
            x1 = x2;
            y1 = y2;
        }


   
   DrawFlatAxes( x2,y2, -Math.sin(oFp), Math.cos(oFp), driverAxisColor);
   DrawFlatAxes( x2,y2, -Math.sin(vFp), Math.cos(vFp), axisColor);
   //g.setColor  ( spFlat.restoreTextColor() );
   spFlat.restoreTextColor();

}

//Vector "direction" must be normed:
//x1,x2 must be already in screen coordinates
static private void DrawFlatAxes( int x1, int y1, double directionX, double directionY, Color axisColor ) {
        int x2 = x1      + (int) (directionX * flatScreenAxisLen);
        int y2 = y1      - (int) (directionY * flatScreenAxisLen);
        spFlat.g.setColor( axisColor );       
        spFlat.g.drawLine(x1,y1, x2,y2);
        spFlat.g.drawString( "y", x2+2,y2+2 );
        x2 = x1      + (int) (directionY * flatScreenAxisLen);
        y2 = y1      + (int) (directionX * flatScreenAxisLen);
        spFlat.g.drawLine(x1,y1, x2,y2);
        spFlat.g.drawString( "x", x2+2,y2+2 );
}



//Auxilary. Axis with origin = begin, unit directon = axis.
static private void DrawAxis( DVector begin, DVector axis, String t ) {
        
        int x = (int) (begin.x * imgRadius - drX);
        int y = (int) (begin.y * imgRadius - drY);
        int z = (int) (begin.z * imgRadius - drZ);

        int a = (int) (axis.x * axisLen);
        int b = (int) (axis.y * axisLen);
        int c = (int) (axis.z * axisLen);

        img.ProjectObsSpaceLineToS( x,y,z, x+a, y+b, z+c, axisColor, t ) ;

}

static private void DrawLocalUBasisOnUSphere( DVector r, UBasis b ) {
        DrawAxis( r, b.e[0], "x" );
        DrawAxis( r, b.e[1], "y" );
        DrawAxis( r, b.e[2], "z" );
} 


public static void displayVesselBasis() {

       spMainScreen.fromTopLine ( "" + v.e[0].x + "      " +  v.e[1].x  +  "     " + v.e[2].x );
       spMainScreen.wr ( "" + v.e[0].y + "      " +  v.e[1].y  +  "     " + v.e[2].y );
       spMainScreen.wr ( "" + v.e[0].z + "      " +  v.e[1].z  +  "     " + v.e[2].z );

       Vec.UBasisDeviation(v);
       spMainScreen.wr (" d  e  v  i  a  t  i  o  n  s :");
       spMainScreen.wr ( "" + Vec.a11);
       spMainScreen.wr ( "" + Vec.a21 + "      " +  Vec.a22);
       spMainScreen.wr ( "" + Vec.a31 + "      " +  Vec.a32  +  "     " + Vec.a33);

       double z = Math.cos(t);
       double w = Math.sin(t);
       double y = w * Math.cos(p);
       double x = w * Math.sin(-p);

       
       spMainScreen.wr (" ");
       spMainScreen.wr ( "e2x=" + x + "  diff=" + (v.e[2].x - x));
       spMainScreen.wr ( "e2y=" + y + "  diff=" + (v.e[2].y - y));
       spMainScreen.wr ( "e2z=" + z + "  diff=" + (v.e[2].z - z));



}

  /** Returns readable VesselMotionFSM state and substate */
  public static String stReadable() {
         String s  = stString[mainState()];
         //GS.con("st=" + s);
         if( (stAte & stSubSTARTUP) == stSubSTARTUP ) {
             s = stString[stSubSTARTUP];
         }else{
             if( (stAte & stSubTURNED) == stSubTURNED ) {
                 s += ".TURNED"; 
             }else{
                 s += ".STRAIGHT"; 
             }
         }
         return s;
  } 

  public static int mainState() {
         return (stAte & stCOMPLETED) | 
                (stAte & stROTATING ) |
                (stAte & stMOVING);
  }




  /** Vessel Motion Digits Display */
  public static void diplayVesselMotionDigits() {

         boolean detailed = false;

         SPad spn = SPad.sPad[SPad.S_];


         double preAzi  = vFpS; //At completed stop.
         double lastAzi = vFp;  //At incompleted rotation/move.
         int wMoveX     = (int)(flatX - vX[Sx]);  
         int wMoveY     = (int)(flatY - vY[Sx]);
         double wTurn   = Vec.fixAzi(lastAzi-preAzi);
         double oVp     = Vec.fixAzi(oFp - lastAzi);


         spn.wr("COURSE       "   +  Vec.RAD2DEG*lastAzi + "^ ");
         spn.wr("POSITION     X=" +  ((int)flatX) + "  Y=" + ((int)flatY) );



         if(        (stAte & stSubSTARTUP) == stSubSTARTUP  ) {
              spn.wr(" ");
              spn.wr(" ");
              spn.wr(" ");
         }else{ if( (stAte & stCOMPLETED ) == stCOMPLETED   ) {
     
              preAzi = vessFp[Sx-1];
              wMoveX = (int)(flatX - vX[Sx-1]);  
              wMoveY = (int)(flatY - vY[Sx-1]);
              wTurn = Vec.fixAzi(lastAzi-preAzi);
              oVp   = Vec.fixAzi(oFp - lastAzi);
            
                     if(detailed) {
                           spn.wr(" ");
                           spn.wr(" ");
                           spn.wr(" ");
                     } 
                           
              spn.wr("MOVE         X=" +  wMoveX  + "  Y="    + wMoveY                    );
              spn.wr("TURN         X=" +  Vec.rad2Degr(wTurn)       );
         
         }else{
              spn.wr("MOVE         X=" +  wMoveX  + "  Y=" + wMoveY                    );
              spn.wr("TURN         X=" +  Vec.rad2Degr(wTurn)       );
                   
                     if(detailed) {
                          double wComplTurn  = 0.;
                          int    wComplMoveX = 0;
                          int    wComplMoveY = 0;
                          if(Sx>0) { 
                             wComplTurn  = Vec.fixAzi(vessFp[Sx] - vessFp[Sx-1]);
                             wComplMoveX = ((int)(vX[Sx]- vX[Sx-1]));
                             wComplMoveY = ((int)(vY[Sx]- vY[Sx-1]));
                             spn.wr("TRIP-COURSE  "   +  Vec.RAD2DEG*preAzi + "^ " );
                             spn.wr("TRIP-MOVE    X=" +  wComplMoveX  + "  Y=" + wComplMoveY               );
                             spn.wr("TRIP-TURN    X=" +  Vec.rad2Degr(wComplTurn)  );
                          }else{
                             spn.wr(" ");
                             spn.wr(" ");
                             spn.wr(" ");
                          }
                   }
        }
        }      
        if( Math.abs(oVp) > sphereNavigationTrustedGeneralAccuracy ) {
            spn.wr("DRIVER       " + oFp + "  = " + Vec.RAD2DEG*oFp + "^ ");
            spn.wr("  FROM VESS. " + oVp + "  = " + Vec.RAD2DEG*oVp + "^ ");
        }
  } // diplayVesselMotionDigits

} //Class HFold end